Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnD.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnD.h	(revision 85625)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnD.h	(revision 85681)
@@ -29,4 +29,7 @@
 class VBoxDnDWnd;
 
+/**
+ * Class for implementing IDataObject for VBoxTray's DnD support.
+ */
 class VBoxDnDDataObject : public IDataObject
 {
@@ -80,15 +83,27 @@
                         LONG lindex = -1, DWORD dwAspect = DVASPECT_CONTENT, DVTARGETDEVICE *pTargetDevice = NULL);
 
+    /** Current drag and drop status. */
     Status      mStatus;
+    /** Internal reference count of this object. */
     LONG        mRefCount;
+    /** Number of native formats registered. This can be a different number than supplied with m_lstFormats. */
     ULONG       mcFormats;
+    /** Array of registered FORMATETC structs. Matches m_cFormats. */
     LPFORMATETC mpFormatEtc;
+    /** Array of registered STGMEDIUM structs. Matches m_cFormats. */
     LPSTGMEDIUM mpStgMedium;
+    /** Event semaphore used for waiting on status changes. */
     RTSEMEVENT  mEventDropped;
+    /** Format of currently retrieved data. */
     RTCString   mstrFormat;
+    /** The retrieved data as a raw buffer. */
     void       *mpvData;
+    /** Raw buffer size (in bytes). */
     size_t      mcbData;
 };
 
+/**
+ * Class for implementing IDropSource for VBoxTray's DnD support.
+ */
 class VBoxDnDDropSource : public IDropSource
 {
@@ -125,4 +140,7 @@
 };
 
+/**
+ * Class for implementing IDropTarget for VBoxTray's DnD support.
+ */
 class VBoxDnDDropTarget : public IDropTarget
 {
@@ -153,6 +171,10 @@
 public:
 
+    /** Returns the data as mutable raw. Use with caution! */
     void *DataMutableRaw(void) const { return mpvData; }
+
+    /** Returns the data size (in bytes). */
     size_t DataSize(void) const { return mcbData; }
+
     RTCString Formats(void) const;
     int WaitForDrop(RTMSINTERVAL msTimeout);
@@ -181,4 +203,7 @@
 };
 
+/**
+ * Class for implementing IEnumFORMATETC for VBoxTray's DnD support.
+ */
 class VBoxDnDEnumFormatEtc : public IEnumFORMATETC
 {
@@ -206,7 +231,11 @@
 private:
 
+    /** Reference count of this object. */
     LONG        m_lRefCount;
+    /** Current index for format iteration. */
     ULONG       m_nIndex;
+    /** Number of format this object contains. */
     ULONG       m_nNumFormats;
+    /** Array of FORMATETC formats this object contains. Matches m_nNumFormats. */
     LPFORMATETC m_pFormatEtc;
 };
@@ -215,5 +244,5 @@
 class VBoxDnDWnd;
 
-/*
+/**
  * A drag'n drop event from the host.
  */
@@ -371,5 +400,7 @@
      *  window messages. */
     RTTHREAD                   hThread;
+    /** Critical section to serialize access. */
     RTCRITSECT                 mCritSect;
+    /** Event semaphore to wait for new DnD events. */
     RTSEMEVENT                 mEventSem;
 #ifdef RT_OS_WINDOWS
@@ -393,6 +424,6 @@
     bool                       mfMouseButtonDown;
 # ifdef VBOX_WITH_DRAG_AND_DROP_GH
-    /** IDropTarget implementation for guest -> host
-     *  support. */
+    /** Pointer to IDropTarget implementation for
+     *  guest -> host support. */
     VBoxDnDDropTarget         *pDropTarget;
 # endif /* VBOX_WITH_DRAG_AND_DROP_GH */
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDataObject.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDataObject.cpp	(revision 85625)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDataObject.cpp	(revision 85681)
@@ -173,13 +173,4 @@
 }
 
-/**
- * Retrieves the data stored in this object and store the result in
- * pMedium.
- *
- * @return  IPRT status code.
- * @return  HRESULT
- * @param   pFormatEtc
- * @param   pMedium
- */
 STDMETHODIMP VBoxDnDDataObject::GetData(LPFORMATETC pFormatEtc, LPSTGMEDIUM pMedium)
 {
@@ -416,12 +407,4 @@
 }
 
-/**
- * Only required for IStream / IStorage interfaces.
- *
- * @return  IPRT status code.
- * @return  HRESULT
- * @param   pFormatEtc
- * @param   pMedium
- */
 STDMETHODIMP VBoxDnDDataObject::GetDataHere(LPFORMATETC pFormatEtc, LPSTGMEDIUM pMedium)
 {
@@ -431,11 +414,4 @@
 }
 
-/**
- * Query if this objects supports a specific format.
- *
- * @return  IPRT status code.
- * @return  HRESULT
- * @param   pFormatEtc
- */
 STDMETHODIMP VBoxDnDDataObject::QueryGetData(LPFORMATETC pFormatEtc)
 {
@@ -496,4 +472,9 @@
  */
 
+/**
+ * Aborts waiting for data being "dropped".
+ *
+ * @returns VBox status code.
+ */
 int VBoxDnDDataObject::Abort(void)
 {
@@ -503,4 +484,10 @@
 }
 
+/**
+ * Static helper function to convert a CLIPFORMAT to a string and return it.
+ *
+ * @returns Pointer to converted stringified CLIPFORMAT, or "unknown" if not found / invalid.
+ * @param   fmt                 CLIPFORMAT to return string for.
+ */
 /* static */
 const char* VBoxDnDDataObject::ClipboardFormatToString(CLIPFORMAT fmt)
@@ -586,4 +573,11 @@
 }
 
+/**
+ * Checks whether a given FORMATETC is supported by this data object and returns its index.
+ *
+ * @returns \c true if format is supported, \c false if not.
+ * @param   pFormatEtc          Pointer to FORMATETC to check for.
+ * @param   puIndex             Where to store the index if format is supported.
+ */
 bool VBoxDnDDataObject::LookupFormatEtc(LPFORMATETC pFormatEtc, ULONG *puIndex)
 {
@@ -632,4 +626,14 @@
 }
 
+/**
+ * Registers a new format with this data object.
+ *
+ * @param   pFormatEtc          Where to store the new format into.
+ * @param   clipFormat          Clipboard format to register.
+ * @param   tyMed               Format medium type to register.
+ * @param   lIndex              Format index to register.
+ * @param   dwAspect            Format aspect to register.
+ * @param   pTargetDevice       Format target device to register.
+ */
 void VBoxDnDDataObject::RegisterFormat(LPFORMATETC pFormatEtc, CLIPFORMAT clipFormat,
                                        TYMED tyMed, LONG lIndex, DWORD dwAspect,
@@ -648,4 +652,9 @@
 }
 
+/**
+ * Sets the current status of this data object.
+ *
+ * @param   status              New status to set.
+ */
 void VBoxDnDDataObject::SetStatus(Status status)
 {
@@ -654,4 +663,12 @@
 }
 
+/**
+ * Signals that data has been "dropped".
+ *
+ * @returns VBox status code.
+ * @param   strFormat           Format of data (MIME string).
+ * @param   pvData              Pointer to data.
+ * @param   cbData              Size (in bytes) of data.
+ */
 int VBoxDnDDataObject::Signal(const RTCString &strFormat,
                               const void *pvData, size_t cbData)
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDropTarget.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDropTarget.cpp	(revision 85625)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDDropTarget.cpp	(revision 85681)
@@ -94,4 +94,9 @@
 }
 
+/**
+ * Static helper function to dump supported formats of a data object.
+ *
+ * @param   pDataObject         Pointer to data object to dump formats for.
+ */
 /* static */
 void VBoxDnDDropTarget::DumpFormats(IDataObject *pDataObject)
@@ -559,4 +564,11 @@
 }
 
+/**
+ * Static helper function to return a drop effect for a given key state and allowed effects.
+ *
+ * @returns Resolved drop effect.
+ * @param   grfKeyState         Key state to determine drop effect for.
+ * @param   dwAllowedEffects    Allowed drop effects to determine drop effect for.
+ */
 /* static */
 DWORD VBoxDnDDropTarget::GetDropEffect(DWORD grfKeyState, DWORD dwAllowedEffects)
@@ -588,4 +600,7 @@
 }
 
+/**
+ * Resets a drop target object.
+ */
 void VBoxDnDDropTarget::reset(void)
 {
@@ -604,4 +619,9 @@
 }
 
+/**
+ * Returns the currently supported formats of a drop target.
+ *
+ * @returns Supported formats.
+ */
 RTCString VBoxDnDDropTarget::Formats(void) const
 {
@@ -609,4 +629,10 @@
 }
 
+/**
+ * Waits for a drop event to happen.
+ *
+ * @returns VBox status code.
+ * @param   msTimeout           Timeout (in ms) to wait for drop event.
+ */
 int VBoxDnDDropTarget::WaitForDrop(RTMSINTERVAL msTimeout)
 {